/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/Element','jquery.sap.strings'],function(q,E){"use strict";var C=function(c,w){this.oWindow=w;this.oCore=c;this.oCore.attachUIUpdated(this.renderDelayed,this);this.renderDelayed();};C.prototype.renderDelayed=function(){if(this.oTimer){this.oWindow.jQuery.sap.clearDelayedCall(this.oTimer);}this.oTimer=this.oWindow.jQuery.sap.delayedCall(500,this,"initDT");restoreLockState(this);supplySelectedTheme(this.oCore.getConfiguration().getTheme());};C.prototype.initDT=function(){restoreTreeCallback();var u=null,U=this.oCore.mUIAreas;for(var i in U){var u=U[i];var r=u.getContent();for(var i=0,l=r.length;i<l;i++){this.renderNodeDT(r[i],0);}}};C.prototype.createTreeNodeDT=function(i,l,t){callback(i,l,t);};C.prototype.createAssocTreeNodeDT=function(i,l,t,s,a){callback(i,l,t,s,a);};C.prototype.renderNodeDT=function(c,l){if(!c){return;}var M=c.getMetadata();var p=M.getAllProperties();for(var P in p){var a=c["get"+P];var N=P;if(!a){N=q.sap.charToUpperCase(N,0);}var v=c["get"+N]();addProperty(c.getId(),P,p[P].type,v!=null?v:"");}var A=M.getAllAggregations();for(var n in A){var b=c.getAggregation(A[n].name);if(b&&b.length){for(var i=0;i<b.length;i++){var o=b[i];if(o instanceof E){this.renderNodeDT(b[i],l+1);}}}else if(b instanceof E){this.renderNodeDT(b,l+1);}}var d=M.getAllAssociations();for(var m in d){var e=c.getAssociation(d[m].name);if(e!=null){var f=d[m].name+e;this.createAssocTreeNodeDT(f,l+2,"Association",c.getId(),e);addProperty(f,d[m].name,"assoc_type",e);addProperty(f,"Name","string",d[m].name);}}};return C;},true);
